

function out=HcfBC(W1a, W2a, W1b, W2b, W1c, W2c, nanbnc, g)


%              1   2   3   4   5   6   7   8   9    10   11   12   13   14   15  16    17
%with order:  m1a s1a m1b s1b m1c s1c m2a s2a m2b  s2b  m2c  s2c  cova covb covc lam1 lam2 

na=nanbnc(1);nb=nanbnc(2);nc=nanbnc(3);

m1ahat=g(1);s1ahat=g(2);
m1bhat=g(3);s1bhat=g(4);
m1chat=g(5);s1chat=g(6);

m2ahat=g(7);s2ahat=g(8);
m2bhat=g(9);s2bhat=g(10);
m2chat=g(11);s2chat=g(12);

cova=g(13);covb=g(14);covc=g(15);
lam1=g(16);lam2=g(17);

Hcf(1,1)=na.*(-2./(2.*s1ahat.^2 - (2.*cova.^2)./s2ahat.^2));
Hcf(1,2)=sum(-(2.*s1ahat.*s2ahat.^2.*(cova.*lam1 - lam2.*s2ahat.^2 - W2a.^lam2.*cova.*lam1 + W1a.^lam1.*lam2.*s2ahat.^2 + cova.*lam1.*lam2.*m2ahat - lam1.*lam2.*m1ahat.*s2ahat.^2))./(lam1.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(1,3)=0;
Hcf(1,4)=0;
Hcf(1,5)=0;
Hcf(1,6)=0;
Hcf(1,7)=na.*(cova./(- cova.^2 + s1ahat.^2.*s2ahat.^2));
Hcf(1,8)=sum((s2ahat.*(2.*cova.^2.*(lam2 - W1a.^lam1.*lam2 + lam1.*lam2.*m1ahat) - 2.*cova.*s1ahat.^2.*(lam1 - W2a.^lam2.*lam1 + lam1.*lam2.*m2ahat)))./(lam1.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(1,9)=0;
Hcf(1,10)=0;
Hcf(1,11)=0;
Hcf(1,12)=0;
Hcf(1,13)=sum((cova.^2.*(lam2.*m2ahat - W2a.^lam2 + 1) + s2ahat.^2.*((lam2.*m2ahat - W2a.^lam2 + 1).*s1ahat.^2 - 2.*cova.*lam2.*m1ahat))./(lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2) - (cova.*s2ahat.^2.*(2.*lam2 - 2.*W1a.^lam1.*lam2))./(lam1.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(1,14)=0;
Hcf(1,15)=0;
Hcf(1,16)=sum((2.*s2ahat.^2.*(W1a.^lam1.*lam1.*log(W1a) - W1a.^lam1 + 1))./(lam1.^2.*(- 2.*cova.^2 + 2.*s1ahat.^2.*s2ahat.^2)));
Hcf(1,17)=sum(-(cova.*(W2a.^lam2.*lam2.*log(W2a) - W2a.^lam2 + 1))./(lam2.^2.*(- cova.^2 + s1ahat.^2.*s2ahat.^2)));

%------------second row:
Hcf(2,1)=Hcf(1,2);
Hcf(2,2)=sum(- (3.*s1ahat.^2.*s2ahat.^6 + cova.^4.*(lam1.^2.*m2ahat.^2 + lam1.^2.*s2ahat.^2) - cova.^3.*(2.*lam1.*m2ahat.*s2ahat.^2 - 2.*W1a.^lam1.*lam1.*m2ahat.*s2ahat.^2 + 2.*lam1.^2.*m1ahat.*m2ahat.*s2ahat.^2) - cova.*(6.*lam1.*m2ahat.*s1ahat.^2.*s2ahat.^4 - 6.*W1a.^lam1.*lam1.*m2ahat.*s1ahat.^2.*s2ahat.^4 + 6.*lam1.^2.*m1ahat.*m2ahat.*s1ahat.^2.*s2ahat.^4) + cova.^2.*(W1a.^(2.*lam1).*s2ahat.^4 - 2.*W1a.^lam1.*s2ahat.^4 + s2ahat.^4 + 2.*lam1.*m1ahat.*s2ahat.^4 + lam1.^2.*m1ahat.^2.*s2ahat.^4 - 2.*W1a.^lam1.*lam1.*m1ahat.*s2ahat.^4 + 3.*lam1.^2.*m2ahat.^2.*s1ahat.^2.*s2ahat.^2) - 6.*W1a.^lam1.*s1ahat.^2.*s2ahat.^6 + 3.*W1a.^(2.*lam1).*s1ahat.^2.*s2ahat.^6 - lam1.^2.*s1ahat.^4.*s2ahat.^6 + 3.*lam1.^2.*m1ahat.^2.*s1ahat.^2.*s2ahat.^6 + 6.*lam1.*m1ahat.*s1ahat.^2.*s2ahat.^6 - 6.*W1a.^lam1.*lam1.*m1ahat.*s1ahat.^2.*s2ahat.^6)./(lam1.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3) - (cova.^4.*(W2a.^(2.*lam2).*lam1.^2 - 2.*W2a.^lam2.*lam1.^2 + lam1.^2) + cova.^2.*(3.*lam1.^2.*s1ahat.^2.*s2ahat.^2 + 3.*W2a.^(2.*lam2).*lam1.^2.*s1ahat.^2.*s2ahat.^2 - 6.*W2a.^lam2.*lam1.^2.*s1ahat.^2.*s2ahat.^2) - lam2.*((2.*W2a.^lam2.*lam1.^2.*m2ahat - 2.*lam1.^2.*m2ahat).*cova.^4 + (2.*lam1.*s2ahat.^2 + 2.*lam1.^2.*m1ahat.*s2ahat.^2 - 2.*W1a.^lam1.*lam1.*s2ahat.^2 - 2.*W2a.^lam2.*lam1.*s2ahat.^2 - 2.*W2a.^lam2.*lam1.^2.*m1ahat.*s2ahat.^2 + 2.*W1a.^lam1.*W2a.^lam2.*lam1.*s2ahat.^2).*cova.^3 + (6.*W2a.^lam2.*lam1.^2.*m2ahat.*s1ahat.^2.*s2ahat.^2 - 6.*lam1.^2.*m2ahat.*s1ahat.^2.*s2ahat.^2).*cova.^2 + (6.*lam1.*s1ahat.^2.*s2ahat.^4 + 6.*lam1.^2.*m1ahat.*s1ahat.^2.*s2ahat.^4 - 6.*W1a.^lam1.*lam1.*s1ahat.^2.*s2ahat.^4 - 6.*W2a.^lam2.*lam1.*s1ahat.^2.*s2ahat.^4 - 6.*W2a.^lam2.*lam1.^2.*m1ahat.*s1ahat.^2.*s2ahat.^4 + 6.*W1a.^lam1.*W2a.^lam2.*lam1.*s1ahat.^2.*s2ahat.^4).*cova))./(lam1.^2.*lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3));
Hcf(2,3)=0;
Hcf(2,4)=0;
Hcf(2,5)=0;
Hcf(2,6)=0;
Hcf(2,7)=sum((s1ahat.*(2.*cova.^2.*(lam1 - W2a.^lam2.*lam1 + lam1.*lam2.*m2ahat) - 2.*cova.*s2ahat.^2.*(lam2 - W1a.^lam1.*lam2 + lam1.*lam2.*m1ahat)))./(lam1.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(2,8)=sum((lam2.*((2.*cova.*s2ahat.^3.*(2.*lam1 + 2.*lam1.^2.*m1ahat - 2.*W1a.^lam1.*lam1 - 2.*W2a.^lam2.*lam1 + 2.*W1a.^lam1.*W2a.^lam2.*lam1 - 2.*W2a.^lam2.*lam1.^2.*m1ahat) - 2.*cova.*s2ahat.*(4.*cova.*lam1.^2.*m2ahat - 4.*W2a.^lam2.*cova.*lam1.^2.*m2ahat)).*s1ahat.^3 + 2.*cova.*s2ahat.*(2.*cova.^2.*lam1 + 2.*cova.^2.*lam1.^2.*m1ahat - 2.*W1a.^lam1.*cova.^2.*lam1 - 2.*W2a.^lam2.*cova.^2.*lam1 - 2.*W2a.^lam2.*cova.^2.*lam1.^2.*m1ahat + 2.*W1a.^lam1.*W2a.^lam2.*cova.^2.*lam1).*s1ahat) - 2.*cova.*s1ahat.^3.*s2ahat.*(2.*cova.*lam1.^2 + 2.*W2a.^(2.*lam2).*cova.*lam1.^2 - 4.*W2a.^lam2.*cova.*lam1.^2))./(lam1.^2.*lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3) - ((4.*cova.^2.*lam1.^2.*m2ahat.^2.*s2ahat - 2.*cova.*s2ahat.^3.*(2.*lam1.*m2ahat + cova.*lam1.^2 + 2.*lam1.^2.*m1ahat.*m2ahat - 2.*W1a.^lam1.*lam1.*m2ahat)).*s1ahat.^3 + (2.*cova.*(2.*cova + 2.*W1a.^(2.*lam1).*cova - 4.*W1a.^lam1.*cova + 2.*cova.*lam1.^2.*m1ahat.^2 + 4.*cova.*lam1.*m1ahat - 4.*W1a.^lam1.*cova.*lam1.*m1ahat).*s2ahat.^3 + 2.*cova.*(cova.^3.*lam1.^2 - 2.*cova.^2.*lam1.*m2ahat + 2.*W1a.^lam1.*cova.^2.*lam1.*m2ahat - 2.*cova.^2.*lam1.^2.*m1ahat.*m2ahat).*s2ahat).*s1ahat)./(lam1.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3));
Hcf(2,9)=0;
Hcf(2,10)=0;
Hcf(2,11)=0;
Hcf(2,12)=0;
Hcf(2,13)=sum((lam1.*(s1ahat.*((6.*W1a.^lam1.*lam2 - 6.*lam2.^2.*m2ahat - 6.*lam2 + 6.*W2a.^lam2.*lam2 - 6.*W1a.^lam1.*W2a.^lam2.*lam2 + 6.*W1a.^lam1.*lam2.^2.*m2ahat).*cova.^2.*s2ahat.^2 + (8.*lam2.^2.*m1ahat - 8.*W1a.^lam1.*lam2.^2.*m1ahat).*cova.*s2ahat.^4) - s1ahat.^3.*s2ahat.^4.*(2.*lam2 + 2.*lam2.^2.*m2ahat - 2.*W1a.^lam1.*lam2 - 2.*W2a.^lam2.*lam2 + 2.*W1a.^lam1.*W2a.^lam2.*lam2 - 2.*W1a.^lam1.*lam2.^2.*m2ahat)) + cova.*s1ahat.*s2ahat.^4.*(4.*W1a.^(2.*lam1).*lam2.^2 - 8.*W1a.^lam1.*lam2.^2 + 4.*lam2.^2))./(lam1.^2.*lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3) - ((s2ahat.^4.*(2.*lam2.*m1ahat + 2.*lam2.^2.*m1ahat.*m2ahat - 2.*W2a.^lam2.*lam2.*m1ahat) - cova.*(s2ahat.^2.*(4.*lam2.*m2ahat - 4.*W2a.^lam2 + 2.*W2a.^(2.*lam2) + 2.*lam2.^2.*m2ahat.^2 - 4.*W2a.^lam2.*lam2.*m2ahat + 2) - 2.*lam2.^2.*s2ahat.^4)).*s1ahat.^3 + (cova.^2.*s2ahat.^2.*(6.*lam2.*m1ahat + 6.*lam2.^2.*m1ahat.*m2ahat - 6.*W2a.^lam2.*lam2.*m1ahat) - cova.^3.*(4.*lam2.*m2ahat - 4.*W2a.^lam2 + 2.*W2a.^(2.*lam2) + 2.*lam2.^2.*m2ahat.^2 + 2.*lam2.^2.*s2ahat.^2 - 4.*W2a.^lam2.*lam2.*m2ahat + 2) - 4.*cova.*lam2.^2.*m1ahat.^2.*s2ahat.^4).*s1ahat)./(lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3));
Hcf(2,14)=0;
Hcf(2,15)=0;Hcf(2,16)=sum((2.*s1ahat.*s2ahat.^2.*(W1a.^lam1.*lam1.*log(W1a) - W1a.^lam1 + 1).*(cova.*lam1 - lam2.*s2ahat.^2 - W2a.^lam2.*cova.*lam1 + W1a.^lam1.*lam2.*s2ahat.^2 + cova.*lam1.*lam2.*m2ahat - lam1.*lam2.*m1ahat.*s2ahat.^2))./(lam1.^3.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));Hcf(2,17)=sum(-(2.*cova.*s1ahat.*(W2a.^lam2.*lam2.*log(W2a) - W2a.^lam2 + 1).*(cova.*lam1 - lam2.*s2ahat.^2 - W2a.^lam2.*cova.*lam1 + W1a.^lam1.*lam2.*s2ahat.^2 + cova.*lam1.*lam2.*m2ahat - lam1.*lam2.*m1ahat.*s2ahat.^2))./(lam1.*lam2.^3.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
%------------third row:
Hcf(3,1)=Hcf(1,3);
Hcf(3,2)=Hcf(2,3);
Hcf(3,3)=nb.*(-2./(2.*s1bhat.^2 - (2.*covb.^2)./s2bhat.^2));
Hcf(3,4)=sum(-(2.*s1bhat.*s2bhat.^2.*(covb.*lam1 - lam2.*s2bhat.^2 - W2b.^lam2.*covb.*lam1 + W1b.^lam1.*lam2.*s2bhat.^2 + covb.*lam1.*lam2.*m2bhat - lam1.*lam2.*m1bhat.*s2bhat.^2))./(lam1.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(3,5)=0;
Hcf(3,6)=0;
Hcf(3,7)=0;
Hcf(3,8)=0;
Hcf(3,9)=covb./(- covb.^2 + s1bhat.^2.*s2bhat.^2);
Hcf(3,10)=sum((s2bhat.*(2.*covb.^2.*(lam2 - W1b.^lam1.*lam2 + lam1.*lam2.*m1bhat) - 2.*covb.*s1bhat.^2.*(lam1 - W2b.^lam2.*lam1 + lam1.*lam2.*m2bhat)))./(lam1.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(3,11)=0;
Hcf(3,12)=0;
Hcf(3,13)=0;
Hcf(3,14)=sum((covb.^2.*(lam2.*m2bhat - W2b.^lam2 + 1) + s2bhat.^2.*((lam2.*m2bhat - W2b.^lam2 + 1).*s1bhat.^2 - 2.*covb.*lam2.*m1bhat))./(lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2) - (covb.*s2bhat.^2.*(2.*lam2 - 2.*W1b.^lam1.*lam2))./(lam1.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(3,15)=0;
Hcf(3,16)=sum((2.*s2bhat.^2.*(W1b.^lam1.*lam1.*log(W1b) - W1b.^lam1 + 1))./(lam1.^2.*(- 2.*covb.^2 + 2.*s1bhat.^2.*s2bhat.^2)));
Hcf(3,17)=sum(-(covb.*(W2b.^lam2.*lam2.*log(W2b) - W2b.^lam2 + 1))./(lam2.^2.*(- covb.^2 + s1bhat.^2.*s2bhat.^2)));


%------------4th row:
Hcf(4,1)=Hcf(1,4);
Hcf(4,2)=Hcf(2,4);
Hcf(4,3)=Hcf(3,4);
Hcf(4,4)=sum(- (3.*s1bhat.^2.*s2bhat.^6 + covb.^4.*(lam1.^2.*m2bhat.^2 + lam1.^2.*s2bhat.^2) - covb.^3.*(2.*lam1.*m2bhat.*s2bhat.^2 - 2.*W1b.^lam1.*lam1.*m2bhat.*s2bhat.^2 + 2.*lam1.^2.*m1bhat.*m2bhat.*s2bhat.^2) - covb.*(6.*lam1.*m2bhat.*s1bhat.^2.*s2bhat.^4 - 6.*W1b.^lam1.*lam1.*m2bhat.*s1bhat.^2.*s2bhat.^4 + 6.*lam1.^2.*m1bhat.*m2bhat.*s1bhat.^2.*s2bhat.^4) + covb.^2.*(W1b.^(2.*lam1).*s2bhat.^4 - 2.*W1b.^lam1.*s2bhat.^4 + s2bhat.^4 + 2.*lam1.*m1bhat.*s2bhat.^4 + lam1.^2.*m1bhat.^2.*s2bhat.^4 - 2.*W1b.^lam1.*lam1.*m1bhat.*s2bhat.^4 + 3.*lam1.^2.*m2bhat.^2.*s1bhat.^2.*s2bhat.^2) - 6.*W1b.^lam1.*s1bhat.^2.*s2bhat.^6 + 3.*W1b.^(2.*lam1).*s1bhat.^2.*s2bhat.^6 - lam1.^2.*s1bhat.^4.*s2bhat.^6 + 3.*lam1.^2.*m1bhat.^2.*s1bhat.^2.*s2bhat.^6 + 6.*lam1.*m1bhat.*s1bhat.^2.*s2bhat.^6 - 6.*W1b.^lam1.*lam1.*m1bhat.*s1bhat.^2.*s2bhat.^6)./(lam1.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3) - (covb.^4.*(W2b.^(2.*lam2).*lam1.^2 - 2.*W2b.^lam2.*lam1.^2 + lam1.^2) + covb.^2.*(3.*lam1.^2.*s1bhat.^2.*s2bhat.^2 + 3.*W2b.^(2.*lam2).*lam1.^2.*s1bhat.^2.*s2bhat.^2 - 6.*W2b.^lam2.*lam1.^2.*s1bhat.^2.*s2bhat.^2) - lam2.*((2.*W2b.^lam2.*lam1.^2.*m2bhat - 2.*lam1.^2.*m2bhat).*covb.^4 + (2.*lam1.*s2bhat.^2 + 2.*lam1.^2.*m1bhat.*s2bhat.^2 - 2.*W1b.^lam1.*lam1.*s2bhat.^2 - 2.*W2b.^lam2.*lam1.*s2bhat.^2 - 2.*W2b.^lam2.*lam1.^2.*m1bhat.*s2bhat.^2 + 2.*W1b.^lam1.*W2b.^lam2.*lam1.*s2bhat.^2).*covb.^3 + (6.*W2b.^lam2.*lam1.^2.*m2bhat.*s1bhat.^2.*s2bhat.^2 - 6.*lam1.^2.*m2bhat.*s1bhat.^2.*s2bhat.^2).*covb.^2 + (6.*lam1.*s1bhat.^2.*s2bhat.^4 + 6.*lam1.^2.*m1bhat.*s1bhat.^2.*s2bhat.^4 - 6.*W1b.^lam1.*lam1.*s1bhat.^2.*s2bhat.^4 - 6.*W2b.^lam2.*lam1.*s1bhat.^2.*s2bhat.^4 - 6.*W2b.^lam2.*lam1.^2.*m1bhat.*s1bhat.^2.*s2bhat.^4 + 6.*W1b.^lam1.*W2b.^lam2.*lam1.*s1bhat.^2.*s2bhat.^4).*covb))./(lam1.^2.*lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3));
Hcf(4,5)=0;
Hcf(4,6)=0;
Hcf(4,7)=0;
Hcf(4,8)=0;
Hcf(4,9)=sum((s1bhat.*(2.*covb.^2.*(lam1 - W2b.^lam2.*lam1 + lam1.*lam2.*m2bhat) - 2.*covb.*s2bhat.^2.*(lam2 - W1b.^lam1.*lam2 + lam1.*lam2.*m1bhat)))./(lam1.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(4,10)=sum((lam2.*((2.*covb.*s2bhat.^3.*(2.*lam1 + 2.*lam1.^2.*m1bhat - 2.*W1b.^lam1.*lam1 - 2.*W2b.^lam2.*lam1 + 2.*W1b.^lam1.*W2b.^lam2.*lam1 - 2.*W2b.^lam2.*lam1.^2.*m1bhat) - 2.*covb.*s2bhat.*(4.*covb.*lam1.^2.*m2bhat - 4.*W2b.^lam2.*covb.*lam1.^2.*m2bhat)).*s1bhat.^3 + 2.*covb.*s2bhat.*(2.*covb.^2.*lam1 + 2.*covb.^2.*lam1.^2.*m1bhat - 2.*W1b.^lam1.*covb.^2.*lam1 - 2.*W2b.^lam2.*covb.^2.*lam1 - 2.*W2b.^lam2.*covb.^2.*lam1.^2.*m1bhat + 2.*W1b.^lam1.*W2b.^lam2.*covb.^2.*lam1).*s1bhat) - 2.*covb.*s1bhat.^3.*s2bhat.*(2.*covb.*lam1.^2 + 2.*W2b.^(2.*lam2).*covb.*lam1.^2 - 4.*W2b.^lam2.*covb.*lam1.^2))./(lam1.^2.*lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3) - ((4.*covb.^2.*lam1.^2.*m2bhat.^2.*s2bhat - 2.*covb.*s2bhat.^3.*(2.*lam1.*m2bhat + covb.*lam1.^2 + 2.*lam1.^2.*m1bhat.*m2bhat - 2.*W1b.^lam1.*lam1.*m2bhat)).*s1bhat.^3 + (2.*covb.*(2.*covb + 2.*W1b.^(2.*lam1).*covb - 4.*W1b.^lam1.*covb + 2.*covb.*lam1.^2.*m1bhat.^2 + 4.*covb.*lam1.*m1bhat - 4.*W1b.^lam1.*covb.*lam1.*m1bhat).*s2bhat.^3 + 2.*covb.*(covb.^3.*lam1.^2 - 2.*covb.^2.*lam1.*m2bhat + 2.*W1b.^lam1.*covb.^2.*lam1.*m2bhat - 2.*covb.^2.*lam1.^2.*m1bhat.*m2bhat).*s2bhat).*s1bhat)./(lam1.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3));
Hcf(4,11)=0;
Hcf(4,12)=0;
Hcf(4,13)=0;
Hcf(4,14)=sum((lam1.*(s1bhat.*((6.*W1b.^lam1.*lam2 - 6.*lam2.^2.*m2bhat - 6.*lam2 + 6.*W2b.^lam2.*lam2 - 6.*W1b.^lam1.*W2b.^lam2.*lam2 + 6.*W1b.^lam1.*lam2.^2.*m2bhat).*covb.^2.*s2bhat.^2 + (8.*lam2.^2.*m1bhat - 8.*W1b.^lam1.*lam2.^2.*m1bhat).*covb.*s2bhat.^4) - s1bhat.^3.*s2bhat.^4.*(2.*lam2 + 2.*lam2.^2.*m2bhat - 2.*W1b.^lam1.*lam2 - 2.*W2b.^lam2.*lam2 + 2.*W1b.^lam1.*W2b.^lam2.*lam2 - 2.*W1b.^lam1.*lam2.^2.*m2bhat)) + covb.*s1bhat.*s2bhat.^4.*(4.*W1b.^(2.*lam1).*lam2.^2 - 8.*W1b.^lam1.*lam2.^2 + 4.*lam2.^2))./(lam1.^2.*lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3) - ((s2bhat.^4.*(2.*lam2.*m1bhat + 2.*lam2.^2.*m1bhat.*m2bhat - 2.*W2b.^lam2.*lam2.*m1bhat) - covb.*(s2bhat.^2.*(4.*lam2.*m2bhat - 4.*W2b.^lam2 + 2.*W2b.^(2.*lam2) + 2.*lam2.^2.*m2bhat.^2 - 4.*W2b.^lam2.*lam2.*m2bhat + 2) - 2.*lam2.^2.*s2bhat.^4)).*s1bhat.^3 + (covb.^2.*s2bhat.^2.*(6.*lam2.*m1bhat + 6.*lam2.^2.*m1bhat.*m2bhat - 6.*W2b.^lam2.*lam2.*m1bhat) - covb.^3.*(4.*lam2.*m2bhat - 4.*W2b.^lam2 + 2.*W2b.^(2.*lam2) + 2.*lam2.^2.*m2bhat.^2 + 2.*lam2.^2.*s2bhat.^2 - 4.*W2b.^lam2.*lam2.*m2bhat + 2) - 4.*covb.*lam2.^2.*m1bhat.^2.*s2bhat.^4).*s1bhat)./(lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3));
Hcf(4,15)=0;
Hcf(4,16)=sum((2.*s1bhat.*s2bhat.^2.*(W1b.^lam1.*lam1.*log(W1b) - W1b.^lam1 + 1).*(covb.*lam1 - lam2.*s2bhat.^2 - W2b.^lam2.*covb.*lam1 + W1b.^lam1.*lam2.*s2bhat.^2 + covb.*lam1.*lam2.*m2bhat - lam1.*lam2.*m1bhat.*s2bhat.^2))./(lam1.^3.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(4,17)=sum(-(2.*covb.*s1bhat.*(W2b.^lam2.*lam2.*log(W2b) - W2b.^lam2 + 1).*(covb.*lam1 - lam2.*s2bhat.^2 - W2b.^lam2.*covb.*lam1 + W1b.^lam1.*lam2.*s2bhat.^2 + covb.*lam1.*lam2.*m2bhat - lam1.*lam2.*m1bhat.*s2bhat.^2))./(lam1.*lam2.^3.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));

%------------5th row:
Hcf(5,1)=Hcf(1,5);
Hcf(5,2)=Hcf(2,5);
Hcf(5,3)=Hcf(3,5);
Hcf(5,4)=Hcf(4,5);
Hcf(5,5)=nc.*(-2./(2.*s1chat.^2 - (2.*covc.^2)./s2chat.^2));
Hcf(5,6)=sum(-(2.*s1chat.*s2chat.^2.*(covc.*lam1 - lam2.*s2chat.^2 - W2c.^lam2.*covc.*lam1 + W1c.^lam1.*lam2.*s2chat.^2 + covc.*lam1.*lam2.*m2chat - lam1.*lam2.*m1chat.*s2chat.^2))./(lam1.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(5,7)=0;
Hcf(5,8)=0;
Hcf(5,9)=0;
Hcf(5,10)=0;
Hcf(5,11)=nc.*(covc./(- covc.^2 + s1chat.^2.*s2chat.^2));
Hcf(5,12)=sum((s2chat.*(2.*covc.^2.*(lam2 - W1c.^lam1.*lam2 + lam1.*lam2.*m1chat) - 2.*covc.*s1chat.^2.*(lam1 - W2c.^lam2.*lam1 + lam1.*lam2.*m2chat)))./(lam1.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(5,13)=0;
Hcf(5,14)=0;
Hcf(5,15)=sum((covc.^2.*(lam2.*m2chat - W2c.^lam2 + 1) + s2chat.^2.*((lam2.*m2chat - W2c.^lam2 + 1).*s1chat.^2 - 2.*covc.*lam2.*m1chat))./(lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2) - (covc.*s2chat.^2.*(2.*lam2 - 2.*W1c.^lam1.*lam2))./(lam1.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(5,16)=sum((2.*s2chat.^2.*(W1c.^lam1.*lam1.*log(W1c) - W1c.^lam1 + 1))./(lam1.^2.*(- 2.*covc.^2 + 2.*s1chat.^2.*s2chat.^2)));
Hcf(5,17)=sum(-(covc.*(W2c.^lam2.*lam2.*log(W2c) - W2c.^lam2 + 1))./(lam2.^2.*(- covc.^2 + s1chat.^2.*s2chat.^2)));


%------------6th row:
Hcf(6,1)=Hcf(1,6);
Hcf(6,2)=Hcf(2,6);
Hcf(6,3)=Hcf(3,6);
Hcf(6,4)=Hcf(4,6);
Hcf(6,5)=Hcf(5,6);
Hcf(6,6)=sum(- (3.*s1chat.^2.*s2chat.^6 + covc.^4.*(lam1.^2.*m2chat.^2 + lam1.^2.*s2chat.^2) - covc.^3.*(2.*lam1.*m2chat.*s2chat.^2 - 2.*W1c.^lam1.*lam1.*m2chat.*s2chat.^2 + 2.*lam1.^2.*m1chat.*m2chat.*s2chat.^2) - covc.*(6.*lam1.*m2chat.*s1chat.^2.*s2chat.^4 - 6.*W1c.^lam1.*lam1.*m2chat.*s1chat.^2.*s2chat.^4 + 6.*lam1.^2.*m1chat.*m2chat.*s1chat.^2.*s2chat.^4) + covc.^2.*(W1c.^(2.*lam1).*s2chat.^4 - 2.*W1c.^lam1.*s2chat.^4 + s2chat.^4 + 2.*lam1.*m1chat.*s2chat.^4 + lam1.^2.*m1chat.^2.*s2chat.^4 - 2.*W1c.^lam1.*lam1.*m1chat.*s2chat.^4 + 3.*lam1.^2.*m2chat.^2.*s1chat.^2.*s2chat.^2) - 6.*W1c.^lam1.*s1chat.^2.*s2chat.^6 + 3.*W1c.^(2.*lam1).*s1chat.^2.*s2chat.^6 - lam1.^2.*s1chat.^4.*s2chat.^6 + 3.*lam1.^2.*m1chat.^2.*s1chat.^2.*s2chat.^6 + 6.*lam1.*m1chat.*s1chat.^2.*s2chat.^6 - 6.*W1c.^lam1.*lam1.*m1chat.*s1chat.^2.*s2chat.^6)./(lam1.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3) - (covc.^4.*(W2c.^(2.*lam2).*lam1.^2 - 2.*W2c.^lam2.*lam1.^2 + lam1.^2) + covc.^2.*(3.*lam1.^2.*s1chat.^2.*s2chat.^2 + 3.*W2c.^(2.*lam2).*lam1.^2.*s1chat.^2.*s2chat.^2 - 6.*W2c.^lam2.*lam1.^2.*s1chat.^2.*s2chat.^2) - lam2.*((2.*W2c.^lam2.*lam1.^2.*m2chat - 2.*lam1.^2.*m2chat).*covc.^4 + (2.*lam1.*s2chat.^2 + 2.*lam1.^2.*m1chat.*s2chat.^2 - 2.*W1c.^lam1.*lam1.*s2chat.^2 - 2.*W2c.^lam2.*lam1.*s2chat.^2 - 2.*W2c.^lam2.*lam1.^2.*m1chat.*s2chat.^2 + 2.*W1c.^lam1.*W2c.^lam2.*lam1.*s2chat.^2).*covc.^3 + (6.*W2c.^lam2.*lam1.^2.*m2chat.*s1chat.^2.*s2chat.^2 - 6.*lam1.^2.*m2chat.*s1chat.^2.*s2chat.^2).*covc.^2 + (6.*lam1.*s1chat.^2.*s2chat.^4 + 6.*lam1.^2.*m1chat.*s1chat.^2.*s2chat.^4 - 6.*W1c.^lam1.*lam1.*s1chat.^2.*s2chat.^4 - 6.*W2c.^lam2.*lam1.*s1chat.^2.*s2chat.^4 - 6.*W2c.^lam2.*lam1.^2.*m1chat.*s1chat.^2.*s2chat.^4 + 6.*W1c.^lam1.*W2c.^lam2.*lam1.*s1chat.^2.*s2chat.^4).*covc))./(lam1.^2.*lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3));
Hcf(6,7)=0;
Hcf(6,8)=0;
Hcf(6,9)=0;
Hcf(6,10)=0;
Hcf(6,11)=sum((s1chat.*(2.*covc.^2.*(lam1 - W2c.^lam2.*lam1 + lam1.*lam2.*m2chat) - 2.*covc.*s2chat.^2.*(lam2 - W1c.^lam1.*lam2 + lam1.*lam2.*m1chat)))./(lam1.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(6,12)=sum((lam2.*((2.*covc.*s2chat.^3.*(2.*lam1 + 2.*lam1.^2.*m1chat - 2.*W1c.^lam1.*lam1 - 2.*W2c.^lam2.*lam1 + 2.*W1c.^lam1.*W2c.^lam2.*lam1 - 2.*W2c.^lam2.*lam1.^2.*m1chat) - 2.*covc.*s2chat.*(4.*covc.*lam1.^2.*m2chat - 4.*W2c.^lam2.*covc.*lam1.^2.*m2chat)).*s1chat.^3 + 2.*covc.*s2chat.*(2.*covc.^2.*lam1 + 2.*covc.^2.*lam1.^2.*m1chat - 2.*W1c.^lam1.*covc.^2.*lam1 - 2.*W2c.^lam2.*covc.^2.*lam1 - 2.*W2c.^lam2.*covc.^2.*lam1.^2.*m1chat + 2.*W1c.^lam1.*W2c.^lam2.*covc.^2.*lam1).*s1chat) - 2.*covc.*s1chat.^3.*s2chat.*(2.*covc.*lam1.^2 + 2.*W2c.^(2.*lam2).*covc.*lam1.^2 - 4.*W2c.^lam2.*covc.*lam1.^2))./(lam1.^2.*lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3) - ((4.*covc.^2.*lam1.^2.*m2chat.^2.*s2chat - 2.*covc.*s2chat.^3.*(2.*lam1.*m2chat + covc.*lam1.^2 + 2.*lam1.^2.*m1chat.*m2chat - 2.*W1c.^lam1.*lam1.*m2chat)).*s1chat.^3 + (2.*covc.*(2.*covc + 2.*W1c.^(2.*lam1).*covc - 4.*W1c.^lam1.*covc + 2.*covc.*lam1.^2.*m1chat.^2 + 4.*covc.*lam1.*m1chat - 4.*W1c.^lam1.*covc.*lam1.*m1chat).*s2chat.^3 + 2.*covc.*(covc.^3.*lam1.^2 - 2.*covc.^2.*lam1.*m2chat + 2.*W1c.^lam1.*covc.^2.*lam1.*m2chat - 2.*covc.^2.*lam1.^2.*m1chat.*m2chat).*s2chat).*s1chat)./(lam1.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3));
Hcf(6,13)=0;
Hcf(6,14)=0;
Hcf(6,15)=sum((lam1.*(s1chat.*((6.*W1c.^lam1.*lam2 - 6.*lam2.^2.*m2chat - 6.*lam2 + 6.*W2c.^lam2.*lam2 - 6.*W1c.^lam1.*W2c.^lam2.*lam2 + 6.*W1c.^lam1.*lam2.^2.*m2chat).*covc.^2.*s2chat.^2 + (8.*lam2.^2.*m1chat - 8.*W1c.^lam1.*lam2.^2.*m1chat).*covc.*s2chat.^4) - s1chat.^3.*s2chat.^4.*(2.*lam2 + 2.*lam2.^2.*m2chat - 2.*W1c.^lam1.*lam2 - 2.*W2c.^lam2.*lam2 + 2.*W1c.^lam1.*W2c.^lam2.*lam2 - 2.*W1c.^lam1.*lam2.^2.*m2chat)) + covc.*s1chat.*s2chat.^4.*(4.*W1c.^(2.*lam1).*lam2.^2 - 8.*W1c.^lam1.*lam2.^2 + 4.*lam2.^2))./(lam1.^2.*lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3) - ((s2chat.^4.*(2.*lam2.*m1chat + 2.*lam2.^2.*m1chat.*m2chat - 2.*W2c.^lam2.*lam2.*m1chat) - covc.*(s2chat.^2.*(4.*lam2.*m2chat - 4.*W2c.^lam2 + 2.*W2c.^(2.*lam2) + 2.*lam2.^2.*m2chat.^2 - 4.*W2c.^lam2.*lam2.*m2chat + 2) - 2.*lam2.^2.*s2chat.^4)).*s1chat.^3 + (covc.^2.*s2chat.^2.*(6.*lam2.*m1chat + 6.*lam2.^2.*m1chat.*m2chat - 6.*W2c.^lam2.*lam2.*m1chat) - covc.^3.*(4.*lam2.*m2chat - 4.*W2c.^lam2 + 2.*W2c.^(2.*lam2) + 2.*lam2.^2.*m2chat.^2 + 2.*lam2.^2.*s2chat.^2 - 4.*W2c.^lam2.*lam2.*m2chat + 2) - 4.*covc.*lam2.^2.*m1chat.^2.*s2chat.^4).*s1chat)./(lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3));
Hcf(6,16)=sum((2.*s1chat.*s2chat.^2.*(W1c.^lam1.*lam1.*log(W1c) - W1c.^lam1 + 1).*(covc.*lam1 - lam2.*s2chat.^2 - W2c.^lam2.*covc.*lam1 + W1c.^lam1.*lam2.*s2chat.^2 + covc.*lam1.*lam2.*m2chat - lam1.*lam2.*m1chat.*s2chat.^2))./(lam1.^3.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(6,17)=sum(-(2.*covc.*s1chat.*(W2c.^lam2.*lam2.*log(W2c) - W2c.^lam2 + 1).*(covc.*lam1 - lam2.*s2chat.^2 - W2c.^lam2.*covc.*lam1 + W1c.^lam1.*lam2.*s2chat.^2 + covc.*lam1.*lam2.*m2chat - lam1.*lam2.*m1chat.*s2chat.^2))./(lam1.*lam2.^3.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));

%------------7th row:
Hcf(7,1)=Hcf(1,7);
Hcf(7,2)=Hcf(2,7);
Hcf(7,3)=Hcf(3,7);
Hcf(7,4)=Hcf(4,7);
Hcf(7,5)=Hcf(5,7);
Hcf(7,6)=Hcf(6,7);
Hcf(7,7)=na.*(-2./(2.*s2ahat.^2 - (2.*cova.^2)./s1ahat.^2));
Hcf(7,8)=sum(-(2.*s1ahat.^2.*s2ahat.*(cova.*lam2 - lam1.*s1ahat.^2 - W1a.^lam1.*cova.*lam2 + W2a.^lam2.*lam1.*s1ahat.^2 + cova.*lam1.*lam2.*m1ahat - lam1.*lam2.*m2ahat.*s1ahat.^2))./(lam1.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(7,9)=0;
Hcf(7,10)=0;
Hcf(7,11)=0;
Hcf(7,12)=0;
Hcf(7,13)=sum((cova.^2.*(lam1.*m1ahat - W1a.^lam1 + 1) + s1ahat.^2.*((lam1.*m1ahat - W1a.^lam1 + 1).*s2ahat.^2 - 2.*cova.*lam1.*m2ahat))./(lam1.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2) - (cova.*s1ahat.^2.*(2.*lam1 - 2.*W2a.^lam2.*lam1))./(lam1.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(7,14)=0;
Hcf(7,15)=0;
Hcf(7,16)=sum(-(cova.*(W1a.^lam1.*lam1.*log(W1a) - W1a.^lam1 + 1))./(lam1.^2.*(- cova.^2 + s1ahat.^2.*s2ahat.^2)));
Hcf(7,17)=sum((2.*s1ahat.^2.*(W2a.^lam2.*lam2.*log(W2a) - W2a.^lam2 + 1))./(lam2.^2.*(- 2.*cova.^2 + 2.*s1ahat.^2.*s2ahat.^2)));



%------------8th row:
Hcf(8,1)=Hcf(1,8);
Hcf(8,2)=Hcf(2,8);
Hcf(8,3)=Hcf(3,8);
Hcf(8,4)=Hcf(4,8);
Hcf(8,5)=Hcf(5,8);
Hcf(8,6)=Hcf(6,8);
Hcf(8,7)=Hcf(7,8);
Hcf(8,8)=sum(- (3.*s1ahat.^6.*s2ahat.^2 + cova.^4.*(lam2.^2.*m1ahat.^2 + lam2.^2.*s1ahat.^2) - cova.^3.*(2.*lam2.*m1ahat.*s1ahat.^2 - 2.*W2a.^lam2.*lam2.*m1ahat.*s1ahat.^2 + 2.*lam2.^2.*m1ahat.*m2ahat.*s1ahat.^2) - cova.*(6.*lam2.*m1ahat.*s1ahat.^4.*s2ahat.^2 - 6.*W2a.^lam2.*lam2.*m1ahat.*s1ahat.^4.*s2ahat.^2 + 6.*lam2.^2.*m1ahat.*m2ahat.*s1ahat.^4.*s2ahat.^2) + cova.^2.*(W2a.^(2.*lam2).*s1ahat.^4 - 2.*W2a.^lam2.*s1ahat.^4 + s1ahat.^4 + 2.*lam2.*m2ahat.*s1ahat.^4 + lam2.^2.*m2ahat.^2.*s1ahat.^4 - 2.*W2a.^lam2.*lam2.*m2ahat.*s1ahat.^4 + 3.*lam2.^2.*m1ahat.^2.*s1ahat.^2.*s2ahat.^2) - 6.*W2a.^lam2.*s1ahat.^6.*s2ahat.^2 + 3.*W2a.^(2.*lam2).*s1ahat.^6.*s2ahat.^2 - lam2.^2.*s1ahat.^6.*s2ahat.^4 + 3.*lam2.^2.*m2ahat.^2.*s1ahat.^6.*s2ahat.^2 + 6.*lam2.*m2ahat.*s1ahat.^6.*s2ahat.^2 - 6.*W2a.^lam2.*lam2.*m2ahat.*s1ahat.^6.*s2ahat.^2)./(lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3) - (cova.^4.*(W1a.^(2.*lam1).*lam2.^2 - 2.*W1a.^lam1.*lam2.^2 + lam2.^2) + cova.^2.*(3.*lam2.^2.*s1ahat.^2.*s2ahat.^2 + 3.*W1a.^(2.*lam1).*lam2.^2.*s1ahat.^2.*s2ahat.^2 - 6.*W1a.^lam1.*lam2.^2.*s1ahat.^2.*s2ahat.^2) - lam1.*((2.*W1a.^lam1.*lam2.^2.*m1ahat - 2.*lam2.^2.*m1ahat).*cova.^4 + (2.*lam2.*s1ahat.^2 + 2.*lam2.^2.*m2ahat.*s1ahat.^2 - 2.*W1a.^lam1.*lam2.*s1ahat.^2 - 2.*W2a.^lam2.*lam2.*s1ahat.^2 - 2.*W1a.^lam1.*lam2.^2.*m2ahat.*s1ahat.^2 + 2.*W1a.^lam1.*W2a.^lam2.*lam2.*s1ahat.^2).*cova.^3 + (6.*W1a.^lam1.*lam2.^2.*m1ahat.*s1ahat.^2.*s2ahat.^2 - 6.*lam2.^2.*m1ahat.*s1ahat.^2.*s2ahat.^2).*cova.^2 + (6.*lam2.*s1ahat.^4.*s2ahat.^2 + 6.*lam2.^2.*m2ahat.*s1ahat.^4.*s2ahat.^2 - 6.*W1a.^lam1.*lam2.*s1ahat.^4.*s2ahat.^2 - 6.*W2a.^lam2.*lam2.*s1ahat.^4.*s2ahat.^2 - 6.*W1a.^lam1.*lam2.^2.*m2ahat.*s1ahat.^4.*s2ahat.^2 + 6.*W1a.^lam1.*W2a.^lam2.*lam2.*s1ahat.^4.*s2ahat.^2).*cova))./(lam1.^2.*lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3));
Hcf(8,9)=0;
Hcf(8,10)=0;
Hcf(8,11)=0;
Hcf(8,12)=0;
Hcf(8,13)=sum((lam2.*(s2ahat.*((6.*W1a.^lam1.*lam1 - 6.*lam1.^2.*m1ahat - 6.*lam1 + 6.*W2a.^lam2.*lam1 - 6.*W1a.^lam1.*W2a.^lam2.*lam1 + 6.*W2a.^lam2.*lam1.^2.*m1ahat).*cova.^2.*s1ahat.^2 + (8.*lam1.^2.*m2ahat - 8.*W2a.^lam2.*lam1.^2.*m2ahat).*cova.*s1ahat.^4) - s1ahat.^4.*s2ahat.^3.*(2.*lam1 + 2.*lam1.^2.*m1ahat - 2.*W1a.^lam1.*lam1 - 2.*W2a.^lam2.*lam1 + 2.*W1a.^lam1.*W2a.^lam2.*lam1 - 2.*W2a.^lam2.*lam1.^2.*m1ahat)) + cova.*s1ahat.^4.*s2ahat.*(4.*W2a.^(2.*lam2).*lam1.^2 - 8.*W2a.^lam2.*lam1.^2 + 4.*lam1.^2))./(lam1.^2.*lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3) - ((s1ahat.^4.*(2.*lam1.*m2ahat + 2.*lam1.^2.*m1ahat.*m2ahat - 2.*W1a.^lam1.*lam1.*m2ahat) - cova.*(s1ahat.^2.*(4.*lam1.*m1ahat - 4.*W1a.^lam1 + 2.*W1a.^(2.*lam1) + 2.*lam1.^2.*m1ahat.^2 - 4.*W1a.^lam1.*lam1.*m1ahat + 2) - 2.*lam1.^2.*s1ahat.^4)).*s2ahat.^3 + (cova.^2.*s1ahat.^2.*(6.*lam1.*m2ahat + 6.*lam1.^2.*m1ahat.*m2ahat - 6.*W1a.^lam1.*lam1.*m2ahat) - cova.^3.*(4.*lam1.*m1ahat - 4.*W1a.^lam1 + 2.*W1a.^(2.*lam1) + 2.*lam1.^2.*m1ahat.^2 + 2.*lam1.^2.*s1ahat.^2 - 4.*W1a.^lam1.*lam1.*m1ahat + 2) - 4.*cova.*lam1.^2.*m2ahat.^2.*s1ahat.^4).*s2ahat)./(lam1.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3));
Hcf(8,14)=0;
Hcf(8,15)=0;
Hcf(8,16)=sum(-(2.*cova.*s2ahat.*(W1a.^lam1.*lam1.*log(W1a) - W1a.^lam1 + 1).*(cova.*lam2 - lam1.*s1ahat.^2 - W1a.^lam1.*cova.*lam2 + W2a.^lam2.*lam1.*s1ahat.^2 + cova.*lam1.*lam2.*m1ahat - lam1.*lam2.*m2ahat.*s1ahat.^2))./(lam1.^3.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(8,17)=sum((2.*s1ahat.^2.*s2ahat.*(W2a.^lam2.*lam2.*log(W2a) - W2a.^lam2 + 1).*(cova.*lam2 - lam1.*s1ahat.^2 - W1a.^lam1.*cova.*lam2 + W2a.^lam2.*lam1.*s1ahat.^2 + cova.*lam1.*lam2.*m1ahat - lam1.*lam2.*m2ahat.*s1ahat.^2))./(lam1.*lam2.^3.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));


%------------9th row:
Hcf(9,1)=Hcf(1,9);
Hcf(9,2)=Hcf(2,9);
Hcf(9,3)=Hcf(3,9);
Hcf(9,4)=Hcf(4,9);
Hcf(9,5)=Hcf(5,9);
Hcf(9,6)=Hcf(6,9);
Hcf(9,7)=Hcf(7,9);
Hcf(9,8)=Hcf(8,9);
Hcf(9,9)=nb.*(-2./(2.*s2bhat.^2 - (2.*covb.^2)./s1bhat.^2));
Hcf(9,10)=sum(-(2.*s1bhat.^2.*s2bhat.*(covb.*lam2 - lam1.*s1bhat.^2 - W1b.^lam1.*covb.*lam2 + W2b.^lam2.*lam1.*s1bhat.^2 + covb.*lam1.*lam2.*m1bhat - lam1.*lam2.*m2bhat.*s1bhat.^2))./(lam1.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(9,11)=0;
Hcf(9,12)=0;
Hcf(9,13)=0;
Hcf(9,14)=sum((covb.^2.*(lam1.*m1bhat - W1b.^lam1 + 1) + s1bhat.^2.*((lam1.*m1bhat - W1b.^lam1 + 1).*s2bhat.^2 - 2.*covb.*lam1.*m2bhat))./(lam1.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2) - (covb.*s1bhat.^2.*(2.*lam1 - 2.*W2b.^lam2.*lam1))./(lam1.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(9,15)=0;
Hcf(9,16)=sum(-(covb.*(W1b.^lam1.*lam1.*log(W1b) - W1b.^lam1 + 1))./(lam1.^2.*(- covb.^2 + s1bhat.^2.*s2bhat.^2)));
Hcf(9,17)=sum((2.*s1bhat.^2.*(W2b.^lam2.*lam2.*log(W2b) - W2b.^lam2 + 1))./(lam2.^2.*(- 2.*covb.^2 + 2.*s1bhat.^2.*s2bhat.^2)));



%------------10th row:
Hcf(10,1)=Hcf(1,10);
Hcf(10,2)=Hcf(2,10);
Hcf(10,3)=Hcf(3,10);
Hcf(10,4)=Hcf(4,10);
Hcf(10,5)=Hcf(5,10);
Hcf(10,6)=Hcf(6,10);
Hcf(10,7)=Hcf(7,10);
Hcf(10,8)=Hcf(8,10);
Hcf(10,9)=Hcf(9,10);
Hcf(10,10)=sum(- (3.*s1bhat.^6.*s2bhat.^2 + covb.^4.*(lam2.^2.*m1bhat.^2 + lam2.^2.*s1bhat.^2) - covb.^3.*(2.*lam2.*m1bhat.*s1bhat.^2 - 2.*W2b.^lam2.*lam2.*m1bhat.*s1bhat.^2 + 2.*lam2.^2.*m1bhat.*m2bhat.*s1bhat.^2) - covb.*(6.*lam2.*m1bhat.*s1bhat.^4.*s2bhat.^2 - 6.*W2b.^lam2.*lam2.*m1bhat.*s1bhat.^4.*s2bhat.^2 + 6.*lam2.^2.*m1bhat.*m2bhat.*s1bhat.^4.*s2bhat.^2) + covb.^2.*(W2b.^(2.*lam2).*s1bhat.^4 - 2.*W2b.^lam2.*s1bhat.^4 + s1bhat.^4 + 2.*lam2.*m2bhat.*s1bhat.^4 + lam2.^2.*m2bhat.^2.*s1bhat.^4 - 2.*W2b.^lam2.*lam2.*m2bhat.*s1bhat.^4 + 3.*lam2.^2.*m1bhat.^2.*s1bhat.^2.*s2bhat.^2) - 6.*W2b.^lam2.*s1bhat.^6.*s2bhat.^2 + 3.*W2b.^(2.*lam2).*s1bhat.^6.*s2bhat.^2 - lam2.^2.*s1bhat.^6.*s2bhat.^4 + 3.*lam2.^2.*m2bhat.^2.*s1bhat.^6.*s2bhat.^2 + 6.*lam2.*m2bhat.*s1bhat.^6.*s2bhat.^2 - 6.*W2b.^lam2.*lam2.*m2bhat.*s1bhat.^6.*s2bhat.^2)./(lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3) - (covb.^4.*(W1b.^(2.*lam1).*lam2.^2 - 2.*W1b.^lam1.*lam2.^2 + lam2.^2) + covb.^2.*(3.*lam2.^2.*s1bhat.^2.*s2bhat.^2 + 3.*W1b.^(2.*lam1).*lam2.^2.*s1bhat.^2.*s2bhat.^2 - 6.*W1b.^lam1.*lam2.^2.*s1bhat.^2.*s2bhat.^2) - lam1.*((2.*W1b.^lam1.*lam2.^2.*m1bhat - 2.*lam2.^2.*m1bhat).*covb.^4 + (2.*lam2.*s1bhat.^2 + 2.*lam2.^2.*m2bhat.*s1bhat.^2 - 2.*W1b.^lam1.*lam2.*s1bhat.^2 - 2.*W2b.^lam2.*lam2.*s1bhat.^2 - 2.*W1b.^lam1.*lam2.^2.*m2bhat.*s1bhat.^2 + 2.*W1b.^lam1.*W2b.^lam2.*lam2.*s1bhat.^2).*covb.^3 + (6.*W1b.^lam1.*lam2.^2.*m1bhat.*s1bhat.^2.*s2bhat.^2 - 6.*lam2.^2.*m1bhat.*s1bhat.^2.*s2bhat.^2).*covb.^2 + (6.*lam2.*s1bhat.^4.*s2bhat.^2 + 6.*lam2.^2.*m2bhat.*s1bhat.^4.*s2bhat.^2 - 6.*W1b.^lam1.*lam2.*s1bhat.^4.*s2bhat.^2 - 6.*W2b.^lam2.*lam2.*s1bhat.^4.*s2bhat.^2 - 6.*W1b.^lam1.*lam2.^2.*m2bhat.*s1bhat.^4.*s2bhat.^2 + 6.*W1b.^lam1.*W2b.^lam2.*lam2.*s1bhat.^4.*s2bhat.^2).*covb))./(lam1.^2.*lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3));
Hcf(10,11)=0;
Hcf(10,12)=0;
Hcf(10,13)=0;
Hcf(10,14)=sum((lam2.*(s2bhat.*((6.*W1b.^lam1.*lam1 - 6.*lam1.^2.*m1bhat - 6.*lam1 + 6.*W2b.^lam2.*lam1 - 6.*W1b.^lam1.*W2b.^lam2.*lam1 + 6.*W2b.^lam2.*lam1.^2.*m1bhat).*covb.^2.*s1bhat.^2 + (8.*lam1.^2.*m2bhat - 8.*W2b.^lam2.*lam1.^2.*m2bhat).*covb.*s1bhat.^4) - s1bhat.^4.*s2bhat.^3.*(2.*lam1 + 2.*lam1.^2.*m1bhat - 2.*W1b.^lam1.*lam1 - 2.*W2b.^lam2.*lam1 + 2.*W1b.^lam1.*W2b.^lam2.*lam1 - 2.*W2b.^lam2.*lam1.^2.*m1bhat)) + covb.*s1bhat.^4.*s2bhat.*(4.*W2b.^(2.*lam2).*lam1.^2 - 8.*W2b.^lam2.*lam1.^2 + 4.*lam1.^2))./(lam1.^2.*lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3) - ((s1bhat.^4.*(2.*lam1.*m2bhat + 2.*lam1.^2.*m1bhat.*m2bhat - 2.*W1b.^lam1.*lam1.*m2bhat) - covb.*(s1bhat.^2.*(4.*lam1.*m1bhat - 4.*W1b.^lam1 + 2.*W1b.^(2.*lam1) + 2.*lam1.^2.*m1bhat.^2 - 4.*W1b.^lam1.*lam1.*m1bhat + 2) - 2.*lam1.^2.*s1bhat.^4)).*s2bhat.^3 + (covb.^2.*s1bhat.^2.*(6.*lam1.*m2bhat + 6.*lam1.^2.*m1bhat.*m2bhat - 6.*W1b.^lam1.*lam1.*m2bhat) - covb.^3.*(4.*lam1.*m1bhat - 4.*W1b.^lam1 + 2.*W1b.^(2.*lam1) + 2.*lam1.^2.*m1bhat.^2 + 2.*lam1.^2.*s1bhat.^2 - 4.*W1b.^lam1.*lam1.*m1bhat + 2) - 4.*covb.*lam1.^2.*m2bhat.^2.*s1bhat.^4).*s2bhat)./(lam1.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3));
Hcf(10,15)=0;
Hcf(10,16)=sum(-(2.*covb.*s2bhat.*(W1b.^lam1.*lam1.*log(W1b) - W1b.^lam1 + 1).*(covb.*lam2 - lam1.*s1bhat.^2 - W1b.^lam1.*covb.*lam2 + W2b.^lam2.*lam1.*s1bhat.^2 + covb.*lam1.*lam2.*m1bhat - lam1.*lam2.*m2bhat.*s1bhat.^2))./(lam1.^3.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(10,17)=sum((2.*s1bhat.^2.*s2bhat.*(W2b.^lam2.*lam2.*log(W2b) - W2b.^lam2 + 1).*(covb.*lam2 - lam1.*s1bhat.^2 - W1b.^lam1.*covb.*lam2 + W2b.^lam2.*lam1.*s1bhat.^2 + covb.*lam1.*lam2.*m1bhat - lam1.*lam2.*m2bhat.*s1bhat.^2))./(lam1.*lam2.^3.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));



%------------11th row:
Hcf(11,1)=Hcf(1,11);
Hcf(11,2)=Hcf(2,11);
Hcf(11,3)=Hcf(3,11);
Hcf(11,4)=Hcf(4,11);
Hcf(11,5)=Hcf(5,11);
Hcf(11,6)=Hcf(6,11);
Hcf(11,7)=Hcf(7,11);
Hcf(11,8)=Hcf(8,11);
Hcf(11,9)=Hcf(9,11);
Hcf(11,10)=Hcf(10,11);
Hcf(11,11)=nc.*(-2./(2.*s2chat.^2 - (2.*covc.^2)./s1chat.^2));
Hcf(11,12)=sum(-(2.*s1chat.^2.*s2chat.*(covc.*lam2 - lam1.*s1chat.^2 - W1c.^lam1.*covc.*lam2 + W2c.^lam2.*lam1.*s1chat.^2 + covc.*lam1.*lam2.*m1chat - lam1.*lam2.*m2chat.*s1chat.^2))./(lam1.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(11,13)=0;
Hcf(11,14)=0;
Hcf(11,15)=sum((covc.^2.*(lam1.*m1chat - W1c.^lam1 + 1) + s1chat.^2.*((lam1.*m1chat - W1c.^lam1 + 1).*s2chat.^2 - 2.*covc.*lam1.*m2chat))./(lam1.*(s1chat.^2.*s2chat.^2 - covc.^2).^2) - (covc.*s1chat.^2.*(2.*lam1 - 2.*W2c.^lam2.*lam1))./(lam1.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(11,16)=sum(-(covc.*(W1c.^lam1.*lam1.*log(W1c) - W1c.^lam1 + 1))./(lam1.^2.*(- covc.^2 + s1chat.^2.*s2chat.^2)));
Hcf(11,17)=sum((2.*s1chat.^2.*(W2c.^lam2.*lam2.*log(W2c) - W2c.^lam2 + 1))./(lam2.^2.*(- 2.*covc.^2 + 2.*s1chat.^2.*s2chat.^2)));



%------------12th row:
Hcf(12,1)=Hcf(1,12);
Hcf(12,2)=Hcf(2,12);
Hcf(12,3)=Hcf(3,12);
Hcf(12,4)=Hcf(4,12);
Hcf(12,5)=Hcf(5,12);
Hcf(12,6)=Hcf(6,12);
Hcf(12,7)=Hcf(7,12);
Hcf(12,8)=Hcf(8,12);
Hcf(12,9)=Hcf(9,12);
Hcf(12,10)=Hcf(10,12);
Hcf(12,11)=Hcf(11,12);
Hcf(12,12)=sum(- (3.*s1chat.^6.*s2chat.^2 + covc.^4.*(lam2.^2.*m1chat.^2 + lam2.^2.*s1chat.^2) - covc.^3.*(2.*lam2.*m1chat.*s1chat.^2 - 2.*W2c.^lam2.*lam2.*m1chat.*s1chat.^2 + 2.*lam2.^2.*m1chat.*m2chat.*s1chat.^2) - covc.*(6.*lam2.*m1chat.*s1chat.^4.*s2chat.^2 - 6.*W2c.^lam2.*lam2.*m1chat.*s1chat.^4.*s2chat.^2 + 6.*lam2.^2.*m1chat.*m2chat.*s1chat.^4.*s2chat.^2) + covc.^2.*(W2c.^(2.*lam2).*s1chat.^4 - 2.*W2c.^lam2.*s1chat.^4 + s1chat.^4 + 2.*lam2.*m2chat.*s1chat.^4 + lam2.^2.*m2chat.^2.*s1chat.^4 - 2.*W2c.^lam2.*lam2.*m2chat.*s1chat.^4 + 3.*lam2.^2.*m1chat.^2.*s1chat.^2.*s2chat.^2) - 6.*W2c.^lam2.*s1chat.^6.*s2chat.^2 + 3.*W2c.^(2.*lam2).*s1chat.^6.*s2chat.^2 - lam2.^2.*s1chat.^6.*s2chat.^4 + 3.*lam2.^2.*m2chat.^2.*s1chat.^6.*s2chat.^2 + 6.*lam2.*m2chat.*s1chat.^6.*s2chat.^2 - 6.*W2c.^lam2.*lam2.*m2chat.*s1chat.^6.*s2chat.^2)./(lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3) - (covc.^4.*(W1c.^(2.*lam1).*lam2.^2 - 2.*W1c.^lam1.*lam2.^2 + lam2.^2) + covc.^2.*(3.*lam2.^2.*s1chat.^2.*s2chat.^2 + 3.*W1c.^(2.*lam1).*lam2.^2.*s1chat.^2.*s2chat.^2 - 6.*W1c.^lam1.*lam2.^2.*s1chat.^2.*s2chat.^2) - lam1.*((2.*W1c.^lam1.*lam2.^2.*m1chat - 2.*lam2.^2.*m1chat).*covc.^4 + (2.*lam2.*s1chat.^2 + 2.*lam2.^2.*m2chat.*s1chat.^2 - 2.*W1c.^lam1.*lam2.*s1chat.^2 - 2.*W2c.^lam2.*lam2.*s1chat.^2 - 2.*W1c.^lam1.*lam2.^2.*m2chat.*s1chat.^2 + 2.*W1c.^lam1.*W2c.^lam2.*lam2.*s1chat.^2).*covc.^3 + (6.*W1c.^lam1.*lam2.^2.*m1chat.*s1chat.^2.*s2chat.^2 - 6.*lam2.^2.*m1chat.*s1chat.^2.*s2chat.^2).*covc.^2 + (6.*lam2.*s1chat.^4.*s2chat.^2 + 6.*lam2.^2.*m2chat.*s1chat.^4.*s2chat.^2 - 6.*W1c.^lam1.*lam2.*s1chat.^4.*s2chat.^2 - 6.*W2c.^lam2.*lam2.*s1chat.^4.*s2chat.^2 - 6.*W1c.^lam1.*lam2.^2.*m2chat.*s1chat.^4.*s2chat.^2 + 6.*W1c.^lam1.*W2c.^lam2.*lam2.*s1chat.^4.*s2chat.^2).*covc))./(lam1.^2.*lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3));
Hcf(12,13)=0;
Hcf(12,14)=0;
Hcf(12,15)=sum((lam2.*(s2chat.*((6.*W1c.^lam1.*lam1 - 6.*lam1.^2.*m1chat - 6.*lam1 + 6.*W2c.^lam2.*lam1 - 6.*W1c.^lam1.*W2c.^lam2.*lam1 + 6.*W2c.^lam2.*lam1.^2.*m1chat).*covc.^2.*s1chat.^2 + (8.*lam1.^2.*m2chat - 8.*W2c.^lam2.*lam1.^2.*m2chat).*covc.*s1chat.^4) - s1chat.^4.*s2chat.^3.*(2.*lam1 + 2.*lam1.^2.*m1chat - 2.*W1c.^lam1.*lam1 - 2.*W2c.^lam2.*lam1 + 2.*W1c.^lam1.*W2c.^lam2.*lam1 - 2.*W2c.^lam2.*lam1.^2.*m1chat)) + covc.*s1chat.^4.*s2chat.*(4.*W2c.^(2.*lam2).*lam1.^2 - 8.*W2c.^lam2.*lam1.^2 + 4.*lam1.^2))./(lam1.^2.*lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3) - ((s1chat.^4.*(2.*lam1.*m2chat + 2.*lam1.^2.*m1chat.*m2chat - 2.*W1c.^lam1.*lam1.*m2chat) - covc.*(s1chat.^2.*(4.*lam1.*m1chat - 4.*W1c.^lam1 + 2.*W1c.^(2.*lam1) + 2.*lam1.^2.*m1chat.^2 - 4.*W1c.^lam1.*lam1.*m1chat + 2) - 2.*lam1.^2.*s1chat.^4)).*s2chat.^3 + (covc.^2.*s1chat.^2.*(6.*lam1.*m2chat + 6.*lam1.^2.*m1chat.*m2chat - 6.*W1c.^lam1.*lam1.*m2chat) - covc.^3.*(4.*lam1.*m1chat - 4.*W1c.^lam1 + 2.*W1c.^(2.*lam1) + 2.*lam1.^2.*m1chat.^2 + 2.*lam1.^2.*s1chat.^2 - 4.*W1c.^lam1.*lam1.*m1chat + 2) - 4.*covc.*lam1.^2.*m2chat.^2.*s1chat.^4).*s2chat)./(lam1.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3));
Hcf(12,16)=sum(-(2.*covc.*s2chat.*(W1c.^lam1.*lam1.*log(W1c) - W1c.^lam1 + 1).*(covc.*lam2 - lam1.*s1chat.^2 - W1c.^lam1.*covc.*lam2 + W2c.^lam2.*lam1.*s1chat.^2 + covc.*lam1.*lam2.*m1chat - lam1.*lam2.*m2chat.*s1chat.^2))./(lam1.^3.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(12,17)=sum((2.*s1chat.^2.*s2chat.*(W2c.^lam2.*lam2.*log(W2c) - W2c.^lam2 + 1).*(covc.*lam2 - lam1.*s1chat.^2 - W1c.^lam1.*covc.*lam2 + W2c.^lam2.*lam1.*s1chat.^2 + covc.*lam1.*lam2.*m1chat - lam1.*lam2.*m2chat.*s1chat.^2))./(lam1.*lam2.^3.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));

%------------13th row:
Hcf(13,1)=Hcf(1,13);
Hcf(13,2)=Hcf(2,13);
Hcf(13,3)=Hcf(3,13);
Hcf(13,4)=Hcf(4,13);
Hcf(13,5)=Hcf(5,13);
Hcf(13,6)=Hcf(6,13);
Hcf(13,7)=Hcf(7,13);
Hcf(13,8)=Hcf(8,13);
Hcf(13,9)=Hcf(9,13);
Hcf(13,10)=Hcf(10,13);
Hcf(13,11)=Hcf(11,13);
Hcf(13,12)=Hcf(12,13);
Hcf(13,13)=sum(- (s1ahat.^2.*(cova.^2.*(6.*lam2.*m2ahat - 6.*W2a.^lam2 + 3.*W2a.^(2.*lam2) + 3.*lam2.^2.*m2ahat.^2 - 6.*W2a.^lam2.*lam2.*m2ahat + 3) - cova.*(6.*lam2.*m1ahat.*s2ahat.^2 - 6.*W2a.^lam2.*lam2.*m1ahat.*s2ahat.^2 + 6.*lam2.^2.*m1ahat.*m2ahat.*s2ahat.^2) + lam2.^2.*m1ahat.^2.*s2ahat.^4) - cova.^3.*(2.*lam2.*m1ahat + 2.*lam2.^2.*m1ahat.*m2ahat - 2.*W2a.^lam2.*lam2.*m1ahat) + s1ahat.^4.*(W2a.^(2.*lam2).*s2ahat.^2 - 2.*W2a.^lam2.*s2ahat.^2 + s2ahat.^2 - lam2.^2.*s2ahat.^4 + 2.*lam2.*m2ahat.*s2ahat.^2 + lam2.^2.*m2ahat.^2.*s2ahat.^2 - 2.*W2a.^lam2.*lam2.*m2ahat.*s2ahat.^2) + cova.^4.*lam2.^2 + 3.*cova.^2.*lam2.^2.*m1ahat.^2.*s2ahat.^2)./(lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3) - (cova.^2.*(3.*lam2.^2.*s2ahat.^2 - 6.*W1a.^lam1.*lam2.^2.*s2ahat.^2 + 3.*W1a.^(2.*lam1).*lam2.^2.*s2ahat.^2) + s1ahat.^2.*(lam2.^2.*s2ahat.^4 - 2.*W1a.^lam1.*lam2.^2.*s2ahat.^4 + W1a.^(2.*lam1).*lam2.^2.*s2ahat.^4) - lam1.*(cova.^3.*(2.*lam2 + 2.*lam2.^2.*m2ahat - 2.*W1a.^lam1.*lam2 - 2.*W2a.^lam2.*lam2 + 2.*W1a.^lam1.*W2a.^lam2.*lam2 - 2.*W1a.^lam1.*lam2.^2.*m2ahat) - cova.^2.*(6.*lam2.^2.*m1ahat.*s2ahat.^2 - 6.*W1a.^lam1.*lam2.^2.*m1ahat.*s2ahat.^2) + s1ahat.^2.*(cova.*(6.*lam2.*s2ahat.^2 + 6.*lam2.^2.*m2ahat.*s2ahat.^2 - 6.*W1a.^lam1.*lam2.*s2ahat.^2 - 6.*W2a.^lam2.*lam2.*s2ahat.^2 - 6.*W1a.^lam1.*lam2.^2.*m2ahat.*s2ahat.^2 + 6.*W1a.^lam1.*W2a.^lam2.*lam2.*s2ahat.^2) - 2.*lam2.^2.*m1ahat.*s2ahat.^4 + 2.*W1a.^lam1.*lam2.^2.*m1ahat.*s2ahat.^4)))./(lam1.^2.*lam2.^2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^3));
Hcf(13,14)=0;
Hcf(13,15)=0;
Hcf(13,16)=sum(-((W1a.^lam1.*lam1.*log(W1a) - W1a.^lam1 + 1).*(cova.^2.*lam1 - 2.*cova.*lam2.*s2ahat.^2 + lam1.*s1ahat.^2.*s2ahat.^2 - W2a.^lam2.*cova.^2.*lam1 + 2.*W1a.^lam1.*cova.*lam2.*s2ahat.^2 + cova.^2.*lam1.*lam2.*m2ahat - W2a.^lam2.*lam1.*s1ahat.^2.*s2ahat.^2 + lam1.*lam2.*m2ahat.*s1ahat.^2.*s2ahat.^2 - 2.*cova.*lam1.*lam2.*m1ahat.*s2ahat.^2))./(lam1.^3.*lam2.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));
Hcf(13,17)=sum(-((W2a.^lam2.*lam2.*log(W2a) - W2a.^lam2 + 1).*(cova.^2.*lam2 - 2.*cova.*lam1.*s1ahat.^2 + lam2.*s1ahat.^2.*s2ahat.^2 - W1a.^lam1.*cova.^2.*lam2 + 2.*W2a.^lam2.*cova.*lam1.*s1ahat.^2 + cova.^2.*lam1.*lam2.*m1ahat - W1a.^lam1.*lam2.*s1ahat.^2.*s2ahat.^2 + lam1.*lam2.*m1ahat.*s1ahat.^2.*s2ahat.^2 - 2.*cova.*lam1.*lam2.*m2ahat.*s1ahat.^2))./(lam1.*lam2.^3.*(s1ahat.^2.*s2ahat.^2 - cova.^2).^2));

%------------14th row:
Hcf(14,1)=Hcf(1,14);
Hcf(14,2)=Hcf(2,14);
Hcf(14,3)=Hcf(3,14);
Hcf(14,4)=Hcf(4,14);
Hcf(14,5)=Hcf(5,14);
Hcf(14,6)=Hcf(6,14);
Hcf(14,7)=Hcf(7,14);
Hcf(14,8)=Hcf(8,14);
Hcf(14,9)=Hcf(9,14);
Hcf(14,10)=Hcf(10,14);
Hcf(14,11)=Hcf(11,14);
Hcf(14,12)=Hcf(12,14);
Hcf(14,13)=Hcf(13,14);
Hcf(14,14)=sum(- (s1bhat.^2.*(covb.^2.*(6.*lam2.*m2bhat - 6.*W2b.^lam2 + 3.*W2b.^(2.*lam2) + 3.*lam2.^2.*m2bhat.^2 - 6.*W2b.^lam2.*lam2.*m2bhat + 3) - covb.*(6.*lam2.*m1bhat.*s2bhat.^2 - 6.*W2b.^lam2.*lam2.*m1bhat.*s2bhat.^2 + 6.*lam2.^2.*m1bhat.*m2bhat.*s2bhat.^2) + lam2.^2.*m1bhat.^2.*s2bhat.^4) - covb.^3.*(2.*lam2.*m1bhat + 2.*lam2.^2.*m1bhat.*m2bhat - 2.*W2b.^lam2.*lam2.*m1bhat) + s1bhat.^4.*(W2b.^(2.*lam2).*s2bhat.^2 - 2.*W2b.^lam2.*s2bhat.^2 + s2bhat.^2 - lam2.^2.*s2bhat.^4 + 2.*lam2.*m2bhat.*s2bhat.^2 + lam2.^2.*m2bhat.^2.*s2bhat.^2 - 2.*W2b.^lam2.*lam2.*m2bhat.*s2bhat.^2) + covb.^4.*lam2.^2 + 3.*covb.^2.*lam2.^2.*m1bhat.^2.*s2bhat.^2)./(lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3) - (covb.^2.*(3.*lam2.^2.*s2bhat.^2 - 6.*W1b.^lam1.*lam2.^2.*s2bhat.^2 + 3.*W1b.^(2.*lam1).*lam2.^2.*s2bhat.^2) + s1bhat.^2.*(lam2.^2.*s2bhat.^4 - 2.*W1b.^lam1.*lam2.^2.*s2bhat.^4 + W1b.^(2.*lam1).*lam2.^2.*s2bhat.^4) - lam1.*(covb.^3.*(2.*lam2 + 2.*lam2.^2.*m2bhat - 2.*W1b.^lam1.*lam2 - 2.*W2b.^lam2.*lam2 + 2.*W1b.^lam1.*W2b.^lam2.*lam2 - 2.*W1b.^lam1.*lam2.^2.*m2bhat) - covb.^2.*(6.*lam2.^2.*m1bhat.*s2bhat.^2 - 6.*W1b.^lam1.*lam2.^2.*m1bhat.*s2bhat.^2) + s1bhat.^2.*(covb.*(6.*lam2.*s2bhat.^2 + 6.*lam2.^2.*m2bhat.*s2bhat.^2 - 6.*W1b.^lam1.*lam2.*s2bhat.^2 - 6.*W2b.^lam2.*lam2.*s2bhat.^2 - 6.*W1b.^lam1.*lam2.^2.*m2bhat.*s2bhat.^2 + 6.*W1b.^lam1.*W2b.^lam2.*lam2.*s2bhat.^2) - 2.*lam2.^2.*m1bhat.*s2bhat.^4 + 2.*W1b.^lam1.*lam2.^2.*m1bhat.*s2bhat.^4)))./(lam1.^2.*lam2.^2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^3));
Hcf(14,15)=0;
Hcf(14,16)=sum(-((W1b.^lam1.*lam1.*log(W1b) - W1b.^lam1 + 1).*(covb.^2.*lam1 - 2.*covb.*lam2.*s2bhat.^2 + lam1.*s1bhat.^2.*s2bhat.^2 - W2b.^lam2.*covb.^2.*lam1 + 2.*W1b.^lam1.*covb.*lam2.*s2bhat.^2 + covb.^2.*lam1.*lam2.*m2bhat - W2b.^lam2.*lam1.*s1bhat.^2.*s2bhat.^2 + lam1.*lam2.*m2bhat.*s1bhat.^2.*s2bhat.^2 - 2.*covb.*lam1.*lam2.*m1bhat.*s2bhat.^2))./(lam1.^3.*lam2.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));
Hcf(14,17)=sum(-((W2b.^lam2.*lam2.*log(W2b) - W2b.^lam2 + 1).*(covb.^2.*lam2 - 2.*covb.*lam1.*s1bhat.^2 + lam2.*s1bhat.^2.*s2bhat.^2 - W1b.^lam1.*covb.^2.*lam2 + 2.*W2b.^lam2.*covb.*lam1.*s1bhat.^2 + covb.^2.*lam1.*lam2.*m1bhat - W1b.^lam1.*lam2.*s1bhat.^2.*s2bhat.^2 + lam1.*lam2.*m1bhat.*s1bhat.^2.*s2bhat.^2 - 2.*covb.*lam1.*lam2.*m2bhat.*s1bhat.^2))./(lam1.*lam2.^3.*(s1bhat.^2.*s2bhat.^2 - covb.^2).^2));



%------------15th row:
Hcf(15,1)=Hcf(1,15);
Hcf(15,2)=Hcf(2,15);
Hcf(15,3)=Hcf(3,15);
Hcf(15,4)=Hcf(4,15);
Hcf(15,5)=Hcf(5,15);
Hcf(15,6)=Hcf(6,15);
Hcf(15,7)=Hcf(7,15);
Hcf(15,8)=Hcf(8,15);
Hcf(15,9)=Hcf(9,15);
Hcf(15,10)=Hcf(10,15);
Hcf(15,11)=Hcf(11,15);
Hcf(15,12)=Hcf(12,15);
Hcf(15,13)=Hcf(13,15);
Hcf(15,14)=Hcf(14,15);
Hcf(15,15)=sum(- (s1chat.^2.*(covc.^2.*(6.*lam2.*m2chat - 6.*W2c.^lam2 + 3.*W2c.^(2.*lam2) + 3.*lam2.^2.*m2chat.^2 - 6.*W2c.^lam2.*lam2.*m2chat + 3) - covc.*(6.*lam2.*m1chat.*s2chat.^2 - 6.*W2c.^lam2.*lam2.*m1chat.*s2chat.^2 + 6.*lam2.^2.*m1chat.*m2chat.*s2chat.^2) + lam2.^2.*m1chat.^2.*s2chat.^4) - covc.^3.*(2.*lam2.*m1chat + 2.*lam2.^2.*m1chat.*m2chat - 2.*W2c.^lam2.*lam2.*m1chat) + s1chat.^4.*(W2c.^(2.*lam2).*s2chat.^2 - 2.*W2c.^lam2.*s2chat.^2 + s2chat.^2 - lam2.^2.*s2chat.^4 + 2.*lam2.*m2chat.*s2chat.^2 + lam2.^2.*m2chat.^2.*s2chat.^2 - 2.*W2c.^lam2.*lam2.*m2chat.*s2chat.^2) + covc.^4.*lam2.^2 + 3.*covc.^2.*lam2.^2.*m1chat.^2.*s2chat.^2)./(lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3) - (covc.^2.*(3.*lam2.^2.*s2chat.^2 - 6.*W1c.^lam1.*lam2.^2.*s2chat.^2 + 3.*W1c.^(2.*lam1).*lam2.^2.*s2chat.^2) + s1chat.^2.*(lam2.^2.*s2chat.^4 - 2.*W1c.^lam1.*lam2.^2.*s2chat.^4 + W1c.^(2.*lam1).*lam2.^2.*s2chat.^4) - lam1.*(covc.^3.*(2.*lam2 + 2.*lam2.^2.*m2chat - 2.*W1c.^lam1.*lam2 - 2.*W2c.^lam2.*lam2 + 2.*W1c.^lam1.*W2c.^lam2.*lam2 - 2.*W1c.^lam1.*lam2.^2.*m2chat) - covc.^2.*(6.*lam2.^2.*m1chat.*s2chat.^2 - 6.*W1c.^lam1.*lam2.^2.*m1chat.*s2chat.^2) + s1chat.^2.*(covc.*(6.*lam2.*s2chat.^2 + 6.*lam2.^2.*m2chat.*s2chat.^2 - 6.*W1c.^lam1.*lam2.*s2chat.^2 - 6.*W2c.^lam2.*lam2.*s2chat.^2 - 6.*W1c.^lam1.*lam2.^2.*m2chat.*s2chat.^2 + 6.*W1c.^lam1.*W2c.^lam2.*lam2.*s2chat.^2) - 2.*lam2.^2.*m1chat.*s2chat.^4 + 2.*W1c.^lam1.*lam2.^2.*m1chat.*s2chat.^4)))./(lam1.^2.*lam2.^2.*(s1chat.^2.*s2chat.^2 - covc.^2).^3));
Hcf(15,16)=sum(-((W1c.^lam1.*lam1.*log(W1c) - W1c.^lam1 + 1).*(covc.^2.*lam1 - 2.*covc.*lam2.*s2chat.^2 + lam1.*s1chat.^2.*s2chat.^2 - W2c.^lam2.*covc.^2.*lam1 + 2.*W1c.^lam1.*covc.*lam2.*s2chat.^2 + covc.^2.*lam1.*lam2.*m2chat - W2c.^lam2.*lam1.*s1chat.^2.*s2chat.^2 + lam1.*lam2.*m2chat.*s1chat.^2.*s2chat.^2 - 2.*covc.*lam1.*lam2.*m1chat.*s2chat.^2))./(lam1.^3.*lam2.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));
Hcf(15,17)=sum(-((W2c.^lam2.*lam2.*log(W2c) - W2c.^lam2 + 1).*(covc.^2.*lam2 - 2.*covc.*lam1.*s1chat.^2 + lam2.*s1chat.^2.*s2chat.^2 - W1c.^lam1.*covc.^2.*lam2 + 2.*W2c.^lam2.*covc.*lam1.*s1chat.^2 + covc.^2.*lam1.*lam2.*m1chat - W1c.^lam1.*lam2.*s1chat.^2.*s2chat.^2 + lam1.*lam2.*m1chat.*s1chat.^2.*s2chat.^2 - 2.*covc.*lam1.*lam2.*m2chat.*s1chat.^2))./(lam1.*lam2.^3.*(s1chat.^2.*s2chat.^2 - covc.^2).^2));


%------------16th row:
Hcf(16,1)=Hcf(1,16);
Hcf(16,2)=Hcf(2,16);
Hcf(16,3)=Hcf(3,16);
Hcf(16,4)=Hcf(4,16);
Hcf(16,5)=Hcf(5,16);
Hcf(16,6)=Hcf(6,16);
Hcf(16,7)=Hcf(7,16);
Hcf(16,8)=Hcf(8,16);
Hcf(16,9)=Hcf(9,16);
Hcf(16,10)=Hcf(10,16);
Hcf(16,11)=Hcf(11,16);
Hcf(16,12)=Hcf(12,16);
Hcf(16,13)=Hcf(13,16);
Hcf(16,14)=Hcf(14,16);
Hcf(16,15)=Hcf(15,16);
Hcf(16,16)=sum(((2.*((W1a.^lam1 - 1)./lam1.^2 - (W1a.^lam1.*log(W1a))./lam1).^2)./s1ahat.^2 - (2.*(m1ahat - (W1a.^lam1 - 1)./lam1).*((2.*W1a.^lam1 - 2)./lam1.^3 - (2.*W1a.^lam1.*log(W1a))./lam1.^2 + (W1a.^lam1.*log(W1a).^2)./lam1))./s1ahat.^2 + (2.*cova.*(m2ahat - (W2a.^lam2 - 1)./lam2).*((2.*W1a.^lam1 - 2)./lam1.^3 - (2.*W1a.^lam1.*log(W1a))./lam1.^2 + (W1a.^lam1.*log(W1a).^2)./lam1))./(s1ahat.^2.*s2ahat.^2))./((2.*cova.^2)./(s1ahat.^2.*s2ahat.^2) - 2)) + sum(((2.*((W1b.^lam1 - 1)./lam1.^2 - (W1b.^lam1.*log(W1b))./lam1).^2)./s1bhat.^2 - (2.*(m1bhat - (W1b.^lam1 - 1)./lam1).*((2.*W1b.^lam1 - 2)./lam1.^3 - (2.*W1b.^lam1.*log(W1b))./lam1.^2 + (W1b.^lam1.*log(W1b).^2)./lam1))./s1bhat.^2 + (2.*covb.*(m2bhat - (W2b.^lam2 - 1)./lam2).*((2.*W1b.^lam1 - 2)./lam1.^3 - (2.*W1b.^lam1.*log(W1b))./lam1.^2 + (W1b.^lam1.*log(W1b).^2)./lam1))./(s1bhat.^2.*s2bhat.^2))./((2.*covb.^2)./(s1bhat.^2.*s2bhat.^2) - 2)) + sum(((2.*((W1c.^lam1 - 1)./lam1.^2 - (W1c.^lam1.*log(W1c))./lam1).^2)./s1chat.^2 - (2.*(m1chat - (W1c.^lam1 - 1)./lam1).*((2.*W1c.^lam1 - 2)./lam1.^3 - (2.*W1c.^lam1.*log(W1c))./lam1.^2 + (W1c.^lam1.*log(W1c).^2)./lam1))./s1chat.^2 + (2.*covc.*(m2chat - (W2c.^lam2 - 1)./lam2).*((2.*W1c.^lam1 - 2)./lam1.^3 - (2.*W1c.^lam1.*log(W1c))./lam1.^2 + (W1c.^lam1.*log(W1c).^2)./lam1))./(s1chat.^2.*s2chat.^2))./((2.*covc.^2)./(s1chat.^2.*s2chat.^2) - 2));
Hcf(16,17)=sum((2.*cova.*(W1a.^lam1.*lam1.*log(W1a) - W1a.^lam1 + 1).*(W2a.^lam2.*lam2.*log(W2a) - W2a.^lam2 + 1))./(lam1.^2.*lam2.^2.*(- 2.*cova.^2 + 2.*s1ahat.^2.*s2ahat.^2))) + sum((2.*covb.*(W1b.^lam1.*lam1.*log(W1b) - W1b.^lam1 + 1).*(W2b.^lam2.*lam2.*log(W2b) - W2b.^lam2 + 1))./(lam1.^2.*lam2.^2.*(- 2.*covb.^2 + 2.*s1bhat.^2.*s2bhat.^2))) + sum((2.*covc.*(W1c.^lam1.*lam1.*log(W1c) - W1c.^lam1 + 1).*(W2c.^lam2.*lam2.*log(W2c) - W2c.^lam2 + 1))./(lam1.^2.*lam2.^2.*(- 2.*covc.^2 + 2.*s1chat.^2.*s2chat.^2)));


%------------17th row:
Hcf(17,1)=Hcf(1,17);
Hcf(17,2)=Hcf(2,17);
Hcf(17,3)=Hcf(3,17);
Hcf(17,4)=Hcf(4,17);
Hcf(17,5)=Hcf(5,17);
Hcf(17,6)=Hcf(6,17);
Hcf(17,7)=Hcf(7,17);
Hcf(17,8)=Hcf(8,17);
Hcf(17,9)=Hcf(9,17);
Hcf(17,10)=Hcf(10,17);
Hcf(17,11)=Hcf(11,17);
Hcf(17,12)=Hcf(12,17);
Hcf(17,13)=Hcf(13,17);
Hcf(17,14)=Hcf(14,17);
Hcf(17,15)=Hcf(15,17);
Hcf(17,16)=Hcf(16,17);
Hcf(17,17)=sum(((2.*((W2a.^lam2 - 1)./lam2.^2 - (W2a.^lam2.*log(W2a))./lam2).^2)./s2ahat.^2 - (2.*(m2ahat - (W2a.^lam2 - 1)./lam2).*((2.*W2a.^lam2 - 2)./lam2.^3 - (2.*W2a.^lam2.*log(W2a))./lam2.^2 + (W2a.^lam2.*log(W2a).^2)./lam2))./s2ahat.^2 + (2.*cova.*(m1ahat - (W1a.^lam1 - 1)./lam1).*((2.*W2a.^lam2 - 2)./lam2.^3 - (2.*W2a.^lam2.*log(W2a))./lam2.^2 + (W2a.^lam2.*log(W2a).^2)./lam2))./(s1ahat.^2.*s2ahat.^2))./((2.*cova.^2)./(s1ahat.^2.*s2ahat.^2) - 2)) + sum(((2.*((W2b.^lam2 - 1)./lam2.^2 - (W2b.^lam2.*log(W2b))./lam2).^2)./s2bhat.^2 - (2.*(m2bhat - (W2b.^lam2 - 1)./lam2).*((2.*W2b.^lam2 - 2)./lam2.^3 - (2.*W2b.^lam2.*log(W2b))./lam2.^2 + (W2b.^lam2.*log(W2b).^2)./lam2))./s2bhat.^2 + (2.*covb.*(m1bhat - (W1b.^lam1 - 1)./lam1).*((2.*W2b.^lam2 - 2)./lam2.^3 - (2.*W2b.^lam2.*log(W2b))./lam2.^2 + (W2b.^lam2.*log(W2b).^2)./lam2))./(s1bhat.^2.*s2bhat.^2))./((2.*covb.^2)./(s1bhat.^2.*s2bhat.^2) - 2)) + sum(((2.*((W2c.^lam2 - 1)./lam2.^2 - (W2c.^lam2.*log(W2c))./lam2).^2)./s2chat.^2 - (2.*(m2chat - (W2c.^lam2 - 1)./lam2).*((2.*W2c.^lam2 - 2)./lam2.^3 - (2.*W2c.^lam2.*log(W2c))./lam2.^2 + (W2c.^lam2.*log(W2c).^2)./lam2))./s2chat.^2 + (2.*covc.*(m1chat - (W1c.^lam1 - 1)./lam1).*((2.*W2c.^lam2 - 2)./lam2.^3 - (2.*W2c.^lam2.*log(W2c))./lam2.^2 + (W2c.^lam2.*log(W2c).^2)./lam2))./(s1chat.^2.*s2chat.^2))./((2.*covc.^2)./(s1chat.^2.*s2chat.^2) - 2));


out=Hcf;
end


